static NewBranch  _NewBranch;

public class NewBranch : Object
{
    public Gtk.Dialog el;
    private NewBranch  _this;

    public static NewBranch singleton()
    {
        if (_NewBranch == null) {
            _NewBranch= new NewBranch();
        }
        return _NewBranch;
    }
    public Xcls_ticketsel ticketsel;
    public Xcls_dbcellrenderer dbcellrenderer;
    public Xcls_dbmodel dbmodel;
    public Xcls_name name;

        // my vars (def)
    public GitRepo? repo;
    public bool running;
    public Gee.ArrayList<GitMonitorQueue> queue;

    // ctor
    public NewBranch()
    {
        _this = this;
        this.el = new Gtk.Dialog();

        // my vars (dec)
        this.repo = null;
        this.running = false;
        this.queue = null;

        // set gobject values
        this.el.title = "Create a working branch ";
        this.el.default_height = 200;
        this.el.default_width = 500;
        this.el.deletable = true;
        this.el.modal = true;
        var child_0 = new Xcls_VBox2( _this );
        child_0.ref();
        this.el.get_content_area().add (  child_0.el  );
        var child_1 = new Xcls_Button10( _this );
        child_1.ref();
        this.el.add_action_widget (  child_1.el , 0 );
        var child_2 = new Xcls_Button11( _this );
        child_2.ref();
        this.el.add_action_widget (  child_2.el , 1 );

        //listeners
        this.el.delete_event.connect( (self, event) => {
            this.el.hide();
            this.running = false;
            return true; 
            //test  
        });
        this.el.response.connect( (self, response_id) =>  { 
          
        	GLib.debug("got %d", (int) response_id);
        	if (response_id == 0) {
        	    _this.el.hide();	
        	    this.running = false; 
        		GitMonitor.gitmonitor.start();	    
        	 	return;
        	}
        	 
        	// have they selected a ticket..
        	// make that the current active ticket?
        	// we really need to store locally what ticket is being worked on..
        	// in theory we could be working on multiple project and not merging..
        	// -- each repo would have their active ticket (only one per repo)
        	// -- so we could just store that in there
        	// -- initial load can check the contents of the ticket files on first scan.
        	var ticket_id = _this.ticketsel.selectedTicketId();
        	
        	var success = true;
            if (this.repo != null) {
            	var bn = _this.name.el.get_text();
            	if (ticket_id != "" ) {
        			success = this.repo.setActiveTicket( RooTicket.singleton().getById(ticket_id), bn);
        		} else {
        			success = this.repo.createBranchNamed(bn);
        		}
            }
            if (success) {
        		GitMonitor.gitmonitor.restoreQueue( this.queue );
        		GitMonitor.gitmonitor.runQueue();    
        		GitMonitor.gitmonitor.start();
        	}
            this.running = false; 	 
        	_this.el.hide();
        	 
        	  
        });
        this.el.show.connect( (self)  => {
         
        
          //test
        });
    }

    // user defined functions
    public   void show ( GitRepo repo, Gee.ArrayList<GitMonitorQueue> queue ) 
    {
         // this.el.set_gravity(Gdk.Gravity.NORTH);
        if (this.running) { // should not happen!!
        	GLib.error("new branch show called, when already being displayed?");
    	}
    	this.queue = queue;
    	
    	this.running  = true;
    	GitMonitor.gitmonitor.stop();
    	
        this.repo = repo;
        
    	this.el.move((Gdk.Screen.width() / 2)- 250 ,0);
           	GLib.debug("Loading tickets"); 
    
    
        this.el.show_all();
     	_this.dbmodel.loadTickets();
    
    }
    public class Xcls_VBox2 : Object
    {
        public Gtk.VBox el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_VBox2(NewBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.VBox( true, 0 );

            // my vars (dec)

            // set gobject values
            var child_0 = new Xcls_Table3( _this );
            child_0.ref();
            this.el.pack_start (  child_0.el , false,false,0 );
        }

        // user defined functions
    }
    public class Xcls_Table3 : Object
    {
        public Gtk.Table el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Table3(NewBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Table( 2, 2, false );

            // my vars (dec)

            // set gobject values
            this.el.margin = 2;
            this.el.column_spacing = 2;
            var child_0 = new Xcls_Label4( _this );
            child_0.ref();
            this.el.attach_defaults (  child_0.el , 0,1,0,1 );
            var child_1 = new Xcls_ticketsel( _this );
            child_1.ref();
            this.el.attach_defaults (  child_1.el , 1,2,0,1 );
            var child_2 = new Xcls_Label8( _this );
            child_2.ref();
            this.el.attach_defaults (  child_2.el , 0,1,1,2 );
            var child_3 = new Xcls_name( _this );
            child_3.ref();
            this.el.attach_defaults (  child_3.el , 1,2,1,2 );
        }

        // user defined functions
    }
    public class Xcls_Label4 : Object
    {
        public Gtk.Label el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Label4(NewBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Label( "Select Ticket" );

            // my vars (dec)

            // set gobject values
            this.el.justify = Gtk.Justification.RIGHT;
            this.el.xalign = 0.900000f;
            this.el.visible = true;
        }

        // user defined functions
    }

    public class Xcls_ticketsel : Object
    {
        public Gtk.ComboBox el;
        private NewBranch  _this;


            // my vars (def)
        public bool loading;

        // ctor
        public Xcls_ticketsel(NewBranch _owner )
        {
            _this = _owner;
            _this.ticketsel = this;
            this.el = new Gtk.ComboBox();

            // my vars (dec)
            this.loading = false;

            // set gobject values
            var child_0 = new Xcls_dbcellrenderer( _this );
            child_0.ref();
            this.el.pack_start (  child_0.el , true );
            var child_1 = new Xcls_dbmodel( _this );
            child_1.ref();
            this.el.set_model (  child_1.el  );

            // init method

            this.el.add_attribute(_this.dbcellrenderer.el , "markup", 1 );

            //listeners
            this.el.changed.connect( () => {
            	if (this.loading) {
            		return;
            	}
            	var ticket_id = this.selectedTicketId();
            	
            	var name = RooTicket.singleton().usernameLocal();
            	
            	if (ticket_id == "" || ticket_id == null) {
            	
            		var dt = new  DateTime.now_local();
            		_this.name.el.set_text("wip_%s_%s".printf(name,dt.format("%Y_%b_%d")));
            		return;
            	}
            	
            	
            	var ticket = RooTicket.singleton().getById(ticket_id);
               
            	_this.name.el.set_text("wip_%s_T%s_%s".printf(name,ticket.id, ticket.summaryToBranchName()));
            	
            	//GLib.debug (//"Selection: %s, %s\n", (string) val1, (string) val2);
            });
        }

        // user defined functions
        public string selectedTicketId () {
        Gtk.TreeIter iter;
        	Value val1;
         
         
        	this.el.get_active_iter (out iter);
        	_this.dbmodel.el.get_value (iter, 0, out val1);
         
        
        	return  (string) val1;
        	
        	
        	
        	
        }
    }
    public class Xcls_dbcellrenderer : Object
    {
        public Gtk.CellRendererText el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_dbcellrenderer(NewBranch _owner )
        {
            _this = _owner;
            _this.dbcellrenderer = this;
            this.el = new Gtk.CellRendererText();

            // my vars (dec)

            // set gobject values
        }

        // user defined functions
    }

    public class Xcls_dbmodel : Object
    {
        public Gtk.ListStore el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_dbmodel(NewBranch _owner )
        {
            _this = _owner;
            _this.dbmodel = this;
            this.el = new Gtk.ListStore( 2, typeof(string),typeof(string) );

            // my vars (dec)

            // set gobject values
        }

        // user defined functions
        public void loadTickets () {
        
            RooTicket.singleton().loadTickets();
            
            _this.ticketsel.loading = true;
        
            this.el.clear();                                    
            Gtk.TreeIter iter;
            var el = this.el;
            
            el.append(out iter);
        
            
            el.set_value(iter, 0, "");
            el.set_value(iter, 1, "-- select a ticket --");
            
            _this.ticketsel.el.set_active_iter(iter);
            var tickets = RooTicket.singleton().tickets;
            foreach(var ticket in tickets) {
            
                el.append(out iter);
                
                el.set_value(iter, 0, ticket.id);
                el.set_value(iter, 1, "#%s [%s] %s".printf( ticket.id, ticket.project_id_name , ticket.summary));
                
                //if (data.get(i) == cur) {
                 //   _this.build_module.el.set_active_iter(iter);
               // }
                
            }
            
            _this.ticketsel.loading = false;
             //this.el.set_sort_column_id(0, Gtk.SortType.ASCENDING);          
                                             
        }
    }


    public class Xcls_Label8 : Object
    {
        public Gtk.Label el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Label8(NewBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Label( "or use this as branch name" );

            // my vars (dec)

            // set gobject values
            this.el.justify = Gtk.Justification.RIGHT;
            this.el.xalign = 0.900000f;
        }

        // user defined functions
    }

    public class Xcls_name : Object
    {
        public Gtk.Entry el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_name(NewBranch _owner )
        {
            _this = _owner;
            _this.name = this;
            this.el = new Gtk.Entry();

            // my vars (dec)

            // set gobject values
            this.el.visible = true;
        }

        // user defined functions
    }



    public class Xcls_Button10 : Object
    {
        public Gtk.Button el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Button10(NewBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Button();

            // my vars (dec)

            // set gobject values
            this.el.relief = Gtk.ReliefStyle.NONE;
            this.el.label = "Do not create Branch";
        }

        // user defined functions
    }

    public class Xcls_Button11 : Object
    {
        public Gtk.Button el;
        private NewBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Button11(NewBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Button();

            // my vars (dec)

            // set gobject values
            this.el.label = "Create Branch";
        }

        // user defined functions
    }

}
